  /**
 * <p>Qualitaets- und UnterstuetzungsAgentur  Landesinstitut fr Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 *
 * @version 2.1 28.04.2014
 */
public class Simulation {

	private int anzahlTeilnehmerImLauf1;
	private int anzahlTeilnehmerImLauf2;

	private Teilnehmerliste alleSpringer;
	private Teilnehmerliste ranglisteNachErstemDurchgang;
	private Teilnehmerliste teilnehmerVorZweitemDurchgang;
	private Teilnehmerliste startlisteZweiterDurchgang;
	private Teilnehmerliste siegerliste;

	public Simulation(int anzahlTeilnehmerImLauf1, int anzahlTeilnehmerImLauf2) {
		this.anzahlTeilnehmerImLauf1 = anzahlTeilnehmerImLauf1;
		this.anzahlTeilnehmerImLauf2 = anzahlTeilnehmerImLauf2;
		alleSpringer = new Teilnehmerliste();
		for (int i = 0; i < this.anzahlTeilnehmerImLauf1; i++) {
			Teilnehmer sp = new Teilnehmer();
			this.alleSpringer.append(sp);
		}
	}

	public void ersterDurchgang() {
		this.ranglisteNachErstemDurchgang = new Teilnehmerliste();
		this.alleSpringer.toFirst();
		while (this.alleSpringer.hasAccess()) {
			Teilnehmer sp = this.alleSpringer.getContent();
			sp.setzePunkte(1, 80, 120);
			this.ranglisteNachErstemDurchgang.einsortieren(sp,
					Teilnehmer.DURCHGANG1);
			this.alleSpringer.next();
		}
	}

	public void erstenDurchgangNachbereiten() {
		this.teilnehmerVorZweitemDurchgang = new Teilnehmerliste();
		this.ranglisteNachErstemDurchgang.toFirst();
		for (int i = 0; i < this.anzahlTeilnehmerImLauf2; i++) {
			Teilnehmer t = this.ranglisteNachErstemDurchgang.getContent();
			this.teilnehmerVorZweitemDurchgang.append(t);
			this.ranglisteNachErstemDurchgang.next();
		}
	}

	public void zweitenDurchgangVorbereiten() {
		this.startlisteZweiterDurchgang = this.teilnehmerVorZweitemDurchgang
				.reverse();
	}

	public void zweiterDurchgang() {
		this.startlisteZweiterDurchgang.toFirst();
		this.siegerliste = new Teilnehmerliste();
		while (this.startlisteZweiterDurchgang.hasAccess()) {
			Teilnehmer dieser = this.startlisteZweiterDurchgang.getContent();
			int punkteImErstenLauf = dieser.gibPunkte(1);
			int unten = (int) (punkteImErstenLauf * 0.8);
			int oben = (int) (punkteImErstenLauf * 1.2);

			dieser.setzePunkte(2, unten, oben);
			siegerliste.einsortieren(dieser, Teilnehmer.GESAMT);
			this.startlisteZweiterDurchgang.next();
		}
	}

	/**
	 * @return the alleSpringer
	 */
	public Teilnehmerliste getAlleSpringer() {
		return alleSpringer;
	}

	/**
	 * @return the ranglisteNachErstemDurchgang
	 */
	public Teilnehmerliste getRanglisteNachErstemDurchgang() {
		return ranglisteNachErstemDurchgang;
	}

	/**
	 * @return the teilnehmerVorZweitemDurchgang
	 */
	public Teilnehmerliste getTeilnehmerVorZweitemDurchgang() {
		return teilnehmerVorZweitemDurchgang;
	}

	/**
	 * @return the startlisteZweiterDurchgang
	 */
	public Teilnehmerliste getStartlisteZweiterDurchgang() {
		return startlisteZweiterDurchgang;
	}

	/**
	 * @return the siegerliste
	 */
	public Teilnehmerliste getSiegerliste() {
		return siegerliste;
	}
}
